//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  LimeGreen
#property indicator_color2  PaleVioletRed
#property indicator_width1  2
#property indicator_width2  2
#property indicator_minimum 0
#property indicator_maximum 1

//
//
//
//
//

extern string TimeFrame1 = "Current time frame";
extern int    Ma1Period  = 12;
extern int    Ma1Price   = PRICE_MEDIAN;
extern int    Ma1Type    = MODE_SMMA;
extern int    Ma1Shift   = 8;
extern string TimeFrame2 = "Current time frame";
extern int    Ma2Period  = 26;
extern int    Ma2Price   = PRICE_MEDIAN;
extern int    Ma2Type    = MODE_SMMA;
extern int    Ma2Shift   = 10;

double buffUp[];
double buffDn[];
double ma1[];
double ma2[];

int      timeFrame1;
int      timeFrame2;
bool     calculateValue;
bool     returnBars;
string   indicatorFileName;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(4);
   SetIndexBuffer(0, buffUp); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1, buffDn); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2, ma1); 
   SetIndexBuffer(3, ma2); 

         //
         //
         //
         //
         //
                  
         indicatorFileName = WindowExpertName();
         returnBars        = (TimeFrame1=="returnBars"); if (returnBars) return(0);
         timeFrame1        = stringToTimeFrame(TimeFrame1);
         timeFrame2        = stringToTimeFrame(TimeFrame2);
   IndicatorShortName(timeFrameToString(timeFrame1)+", "+timeFrameToString(timeFrame2)+"   ShitedMAs trend");
   return(0);
}
int deinit()
{
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int i,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(MathMax(Bars-counted_bars,-MathMin(Ma1Shift,Ma2Shift)),Bars-1);
         if (returnBars) { buffUp[0] = limit+1; return(0); }
         if (timeFrame1!=Period()) limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame1,indicatorFileName,"returnBars",0,0)*timeFrame1/Period()));
         if (timeFrame2!=Period()) limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame2,indicatorFileName,"returnBars",0,0)*timeFrame2/Period()));
         
   //
   //
   //
   //
   //

      for(i=limit; i>=0; i--)
      {
         ma1[i] = iMA(NULL,timeFrame1,Ma1Period,Ma1Shift,Ma1Type,Ma1Price,iBarShift(NULL,timeFrame1,Time[i]));
         ma2[i] = iMA(NULL,timeFrame2,Ma2Period,Ma2Shift,Ma2Type,Ma2Price,iBarShift(NULL,timeFrame2,Time[i]));
      }      
      for (i=limit; i>=0; i--)
      {
         buffUp[i] = EMPTY_VALUE;
         buffDn[i] = EMPTY_VALUE;
         if (ma1[i] !=0 && ma2[i] !=0)
         {
            double diff = ma1[i]-ma2[i];
               if (diff>0) buffUp[i] = 1;
               if (diff<0) buffDn[i] = 1;
         }               
      }
      return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}